/* Device.c generated by valac 0.54.6, the Vala compiler
 * generated from Device.vala, do not modify */

/*-
 * Copyright (c) 2017-2017 Artem Anufrij <artem.anufrij@live.de>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Artem Anufrij <artem.anufrij@live.de>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define IMAGEBURNER_TYPE_DEVICE (imageburner_device_get_type ())
#define IMAGEBURNER_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), IMAGEBURNER_TYPE_DEVICE, ImageburnerDevice))
#define IMAGEBURNER_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), IMAGEBURNER_TYPE_DEVICE, ImageburnerDeviceClass))
#define IMAGEBURNER_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), IMAGEBURNER_TYPE_DEVICE))
#define IMAGEBURNER_IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), IMAGEBURNER_TYPE_DEVICE))
#define IMAGEBURNER_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), IMAGEBURNER_TYPE_DEVICE, ImageburnerDeviceClass))

typedef struct _ImageburnerDevice ImageburnerDevice;
typedef struct _ImageburnerDeviceClass ImageburnerDeviceClass;
typedef struct _ImageburnerDevicePrivate ImageburnerDevicePrivate;
enum  {
	IMAGEBURNER_DEVICE_0_PROPERTY,
	IMAGEBURNER_DEVICE_DRIVE_PROPERTY,
	IMAGEBURNER_DEVICE_UNIX_DEVICE_PROPERTY,
	IMAGEBURNER_DEVICE_IS_CARD_PROPERTY,
	IMAGEBURNER_DEVICE_NUM_PROPERTIES
};
static GParamSpec* imageburner_device_properties[IMAGEBURNER_DEVICE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _ImageburnerDevice {
	GtkFlowBoxChild parent_instance;
	ImageburnerDevicePrivate * priv;
};

struct _ImageburnerDeviceClass {
	GtkFlowBoxChildClass parent_class;
};

struct _ImageburnerDevicePrivate {
	GtkGrid* content;
	GtkImage* icon;
	GtkLabel* title;
	GDrive* _drive;
	gchar* _unix_device;
};

static gint ImageburnerDevice_private_offset;
static gpointer imageburner_device_parent_class = NULL;

VALA_EXTERN GType imageburner_device_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ImageburnerDevice, g_object_unref)
VALA_EXTERN ImageburnerDevice* imageburner_device_new (GDrive* d);
VALA_EXTERN ImageburnerDevice* imageburner_device_construct (GType object_type,
                                                 GDrive* d);
static void imageburner_device_set_drive (ImageburnerDevice* self,
                                   GDrive* value);
static void imageburner_device_set_unix_device (ImageburnerDevice* self,
                                         const gchar* value);
VALA_EXTERN GtkImage* imageburner_device_get_medium_icon (ImageburnerDevice* self);
VALA_EXTERN gboolean imageburner_device_get_is_card (ImageburnerDevice* self);
VALA_EXTERN GDrive* imageburner_device_get_drive (ImageburnerDevice* self);
VALA_EXTERN GtkImage* imageburner_device_get_large_icon (ImageburnerDevice* self);
VALA_EXTERN void imageburner_device_umount_all_volumes (ImageburnerDevice* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
VALA_EXTERN const gchar* imageburner_device_get_unix_device (ImageburnerDevice* self);
static GObject * imageburner_device_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void imageburner_device_finalize (GObject * obj);
static GType imageburner_device_get_type_once (void);
static void _vala_imageburner_device_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_imageburner_device_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);

static inline gpointer
imageburner_device_get_instance_private (ImageburnerDevice* self)
{
	return G_STRUCT_MEMBER_P (self, ImageburnerDevice_private_offset);
}

ImageburnerDevice*
imageburner_device_construct (GType object_type,
                              GDrive* d)
{
	ImageburnerDevice * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GtkImage* _tmp2_;
	GtkImage* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkGrid* _tmp8_;
	GtkImage* _tmp9_;
	GtkGrid* _tmp10_;
	GtkLabel* _tmp11_;
	g_return_val_if_fail (d != NULL, NULL);
	self = (ImageburnerDevice*) g_object_new (object_type, NULL);
	imageburner_device_set_drive (self, d);
	_tmp0_ = g_drive_get_identifier (d, "unix-device");
	_tmp1_ = _tmp0_;
	imageburner_device_set_unix_device (self, _tmp1_);
	_g_free0 (_tmp1_);
	_tmp2_ = imageburner_device_get_medium_icon (self);
	_g_object_unref0 (self->priv->icon);
	self->priv->icon = _tmp2_;
	_tmp3_ = self->priv->icon;
	g_object_set ((GtkWidget*) _tmp3_, "margin", 6, NULL);
	_tmp4_ = g_drive_get_name (d);
	_tmp5_ = _tmp4_;
	_tmp6_ = (GtkLabel*) gtk_label_new (_tmp5_);
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (self->priv->title);
	self->priv->title = _tmp6_;
	_g_free0 (_tmp5_);
	_tmp7_ = self->priv->title;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp7_, 6);
	_tmp8_ = self->priv->content;
	_tmp9_ = self->priv->icon;
	gtk_grid_attach (_tmp8_, (GtkWidget*) _tmp9_, 0, 0, 1, 1);
	_tmp10_ = self->priv->content;
	_tmp11_ = self->priv->title;
	gtk_grid_attach (_tmp10_, (GtkWidget*) _tmp11_, 1, 0, 1, 1);
	return self;
}

ImageburnerDevice*
imageburner_device_new (GDrive* d)
{
	return imageburner_device_construct (IMAGEBURNER_TYPE_DEVICE, d);
}

GtkImage*
imageburner_device_get_medium_icon (ImageburnerDevice* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GDrive* _tmp3_;
	GIcon* _tmp4_;
	GIcon* _tmp5_;
	GtkImage* _tmp6_;
	GtkImage* _tmp7_;
	GtkImage* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = imageburner_device_get_is_card (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		GtkImage* _tmp2_;
		_tmp2_ = (GtkImage*) gtk_image_new_from_icon_name ("media-flash", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
		g_object_ref_sink (_tmp2_);
		result = _tmp2_;
		return result;
	}
	_tmp3_ = self->priv->_drive;
	_tmp4_ = g_drive_get_icon (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = (GtkImage*) gtk_image_new_from_gicon (_tmp5_, (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp6_);
	_tmp7_ = _tmp6_;
	_g_object_unref0 (_tmp5_);
	result = _tmp7_;
	return result;
}

GtkImage*
imageburner_device_get_large_icon (ImageburnerDevice* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GDrive* _tmp3_;
	GIcon* _tmp4_;
	GIcon* _tmp5_;
	GtkImage* _tmp6_;
	GtkImage* _tmp7_;
	GtkImage* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = imageburner_device_get_is_card (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		GtkImage* _tmp2_;
		_tmp2_ = (GtkImage*) gtk_image_new_from_icon_name ("media-flash", (GtkIconSize) GTK_ICON_SIZE_DIALOG);
		g_object_ref_sink (_tmp2_);
		result = _tmp2_;
		return result;
	}
	_tmp3_ = self->priv->_drive;
	_tmp4_ = g_drive_get_icon (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = (GtkImage*) gtk_image_new_from_gicon (_tmp5_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
	g_object_ref_sink (_tmp6_);
	_tmp7_ = _tmp6_;
	_g_object_unref0 (_tmp5_);
	result = _tmp7_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

void
imageburner_device_umount_all_volumes (ImageburnerDevice* self)
{
	GDrive* _tmp0_;
	GList* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_drive;
	_tmp1_ = g_drive_get_volumes (_tmp0_);
	{
		GList* volume_collection = NULL;
		GList* volume_it = NULL;
		volume_collection = _tmp1_;
		for (volume_it = volume_collection; volume_it != NULL; volume_it = volume_it->next) {
			GVolume* _tmp2_;
			GVolume* volume = NULL;
			_tmp2_ = _g_object_ref0 ((GVolume*) volume_it->data);
			volume = _tmp2_;
			{
				GVolume* _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				GMount* mount = NULL;
				GVolume* _tmp6_;
				GMount* _tmp7_;
				GMount* _tmp8_;
				_tmp3_ = volume;
				_tmp4_ = g_volume_get_name (_tmp3_);
				_tmp5_ = _tmp4_;
				g_debug ("Device.vala:82: volume: %s", _tmp5_);
				_g_free0 (_tmp5_);
				_tmp6_ = volume;
				_tmp7_ = g_volume_get_mount (_tmp6_);
				mount = _tmp7_;
				_tmp8_ = mount;
				if (_tmp8_ != NULL) {
					GMount* _tmp9_;
					gchar* _tmp10_;
					gchar* _tmp11_;
					GMount* _tmp12_;
					_tmp9_ = mount;
					_tmp10_ = g_mount_get_name (_tmp9_);
					_tmp11_ = _tmp10_;
					g_debug ("Device.vala:86: umount %s", _tmp11_);
					_g_free0 (_tmp11_);
					_tmp12_ = mount;
					g_mount_unmount_with_operation (_tmp12_, G_MOUNT_UNMOUNT_FORCE, NULL, NULL, NULL, NULL);
				}
				_g_object_unref0 (mount);
				_g_object_unref0 (volume);
			}
		}
		(volume_collection == NULL) ? NULL : (volume_collection = (_g_list_free__g_object_unref0_ (volume_collection), NULL));
	}
}

GDrive*
imageburner_device_get_drive (ImageburnerDevice* self)
{
	GDrive* result;
	GDrive* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_drive;
	result = _tmp0_;
	return result;
}

static void
imageburner_device_set_drive (ImageburnerDevice* self,
                              GDrive* value)
{
	GDrive* old_value;
	g_return_if_fail (self != NULL);
	old_value = imageburner_device_get_drive (self);
	if (old_value != value) {
		GDrive* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_drive);
		self->priv->_drive = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, imageburner_device_properties[IMAGEBURNER_DEVICE_DRIVE_PROPERTY]);
	}
}

const gchar*
imageburner_device_get_unix_device (ImageburnerDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_unix_device;
	result = _tmp0_;
	return result;
}

static void
imageburner_device_set_unix_device (ImageburnerDevice* self,
                                    const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = imageburner_device_get_unix_device (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_unix_device);
		self->priv->_unix_device = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, imageburner_device_properties[IMAGEBURNER_DEVICE_UNIX_DEVICE_PROPERTY]);
	}
}

gboolean
imageburner_device_get_is_card (ImageburnerDevice* self)
{
	gboolean result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_unix_device;
	result = g_str_has_prefix (_tmp0_, "/dev/mmc");
	return result;
}

static GObject *
imageburner_device_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ImageburnerDevice * self;
	GtkGrid* _tmp0_;
	GtkGrid* _tmp1_;
	GtkGrid* _tmp2_;
	GtkGrid* _tmp3_;
	parent_class = G_OBJECT_CLASS (imageburner_device_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, IMAGEBURNER_TYPE_DEVICE, ImageburnerDevice);
	_tmp0_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->content);
	self->priv->content = _tmp0_;
	_tmp1_ = self->priv->content;
	gtk_grid_set_row_spacing (_tmp1_, 12);
	_tmp2_ = self->priv->content;
	gtk_widget_set_valign ((GtkWidget*) _tmp2_, GTK_ALIGN_CENTER);
	_tmp3_ = self->priv->content;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp3_);
	return obj;
}

static void
imageburner_device_class_init (ImageburnerDeviceClass * klass,
                               gpointer klass_data)
{
	imageburner_device_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ImageburnerDevice_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_imageburner_device_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_imageburner_device_set_property;
	G_OBJECT_CLASS (klass)->constructor = imageburner_device_constructor;
	G_OBJECT_CLASS (klass)->finalize = imageburner_device_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), IMAGEBURNER_DEVICE_DRIVE_PROPERTY, imageburner_device_properties[IMAGEBURNER_DEVICE_DRIVE_PROPERTY] = g_param_spec_object ("drive", "drive", "drive", g_drive_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), IMAGEBURNER_DEVICE_UNIX_DEVICE_PROPERTY, imageburner_device_properties[IMAGEBURNER_DEVICE_UNIX_DEVICE_PROPERTY] = g_param_spec_string ("unix-device", "unix-device", "unix-device", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), IMAGEBURNER_DEVICE_IS_CARD_PROPERTY, imageburner_device_properties[IMAGEBURNER_DEVICE_IS_CARD_PROPERTY] = g_param_spec_boolean ("is-card", "is-card", "is-card", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
imageburner_device_instance_init (ImageburnerDevice * self,
                                  gpointer klass)
{
	self->priv = imageburner_device_get_instance_private (self);
}

static void
imageburner_device_finalize (GObject * obj)
{
	ImageburnerDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, IMAGEBURNER_TYPE_DEVICE, ImageburnerDevice);
	_g_object_unref0 (self->priv->content);
	_g_object_unref0 (self->priv->icon);
	_g_object_unref0 (self->priv->title);
	_g_object_unref0 (self->priv->_drive);
	_g_free0 (self->priv->_unix_device);
	G_OBJECT_CLASS (imageburner_device_parent_class)->finalize (obj);
}

static GType
imageburner_device_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ImageburnerDeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) imageburner_device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ImageburnerDevice), 0, (GInstanceInitFunc) imageburner_device_instance_init, NULL };
	GType imageburner_device_type_id;
	imageburner_device_type_id = g_type_register_static (gtk_flow_box_child_get_type (), "ImageburnerDevice", &g_define_type_info, 0);
	ImageburnerDevice_private_offset = g_type_add_instance_private (imageburner_device_type_id, sizeof (ImageburnerDevicePrivate));
	return imageburner_device_type_id;
}

GType
imageburner_device_get_type (void)
{
	static volatile gsize imageburner_device_type_id__volatile = 0;
	if (g_once_init_enter (&imageburner_device_type_id__volatile)) {
		GType imageburner_device_type_id;
		imageburner_device_type_id = imageburner_device_get_type_once ();
		g_once_init_leave (&imageburner_device_type_id__volatile, imageburner_device_type_id);
	}
	return imageburner_device_type_id__volatile;
}

static void
_vala_imageburner_device_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	ImageburnerDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, IMAGEBURNER_TYPE_DEVICE, ImageburnerDevice);
	switch (property_id) {
		case IMAGEBURNER_DEVICE_DRIVE_PROPERTY:
		g_value_set_object (value, imageburner_device_get_drive (self));
		break;
		case IMAGEBURNER_DEVICE_UNIX_DEVICE_PROPERTY:
		g_value_set_string (value, imageburner_device_get_unix_device (self));
		break;
		case IMAGEBURNER_DEVICE_IS_CARD_PROPERTY:
		g_value_set_boolean (value, imageburner_device_get_is_card (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_imageburner_device_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	ImageburnerDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, IMAGEBURNER_TYPE_DEVICE, ImageburnerDevice);
	switch (property_id) {
		case IMAGEBURNER_DEVICE_DRIVE_PROPERTY:
		imageburner_device_set_drive (self, g_value_get_object (value));
		break;
		case IMAGEBURNER_DEVICE_UNIX_DEVICE_PROPERTY:
		imageburner_device_set_unix_device (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

